#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <string.h>
typedef struct
{
	char	suiteName[20];
	int		value;		// -1ならJOKER
} CARD;
#define HEART	0
#define SPADE	1
#define DIAMOND	2
#define CLUB	3
#define JOKER_VALUE -1

int		inputNumber(char* msg);
CARD*	createCards(int jokers);
void	shuffleCard(CARD* pcard, int jokers);
void	showTopCards(CARD* pcard);

int		main(void)
{
	int jokers = inputNumber("ジョーカーの枚数");
	CARD* pcard = createCards(jokers);
	if (NULL == pcard){
		printf("mallocエラー \n");
		return 0;
	}
	shuffleCard(pcard, jokers);
	showTopCards(pcard);
	free(pcard);
	return 0;
}
void	shuffleCard(CARD* pcard, int jokers)
{
	int count, r_1, r_2;
	CARD save;
	srand(time(NULL));
	for (count = 0; count < 500; ++count){
		r_1 = rand() % (13 * 4 + jokers);
		r_2 = rand() % (13 * 4 + jokers);
		save = *(pcard + r_1);
		*(pcard + r_1) = *(pcard + r_2);
		*(pcard + r_2) = save;
	}
}
int		inputNumber(char* msg)
{
	int num = 0;
	printf("%s を数値で入力してください", msg);
	scanf("%d", &num);
	return num;
}
void	displayCard(CARD* pcard)
{
	if (JOKER_VALUE == pcard->value)
		printf("ジョーカー \n");
	else
		printf("%s %02d \n", 
			pcard->suiteName, pcard->value + 1);
}
void	showTopCards(CARD* pcard)
{
	int number = inputNumber("表示枚数");
	int count;
	for (count = 0; count < number; ++count)
		displayCard(pcard + count);
}
void	setCard(CARD* pcard, int suite, int value)
{
	switch (suite){
	case HEART:
		strcpy(pcard->suiteName, "ハート");
		break;
	case SPADE:
		strcpy(pcard->suiteName, "スペード");
		break;
	case DIAMOND:
		strcpy(pcard->suiteName, "ダイヤ");
		break;
	case CLUB:
		strcpy(pcard->suiteName, "クラブ");
		break;
	}
	pcard->value = value;
}
CARD*	createCards(int jokers)
{
	int suite, value;
	CARD* pcard = (CARD*)malloc(sizeof(CARD) * (13 * 4 + jokers));
	CARD* ptr;
	if (NULL == pcard)
		return NULL;
	ptr = pcard;
	for (suite = 0; suite < 4; ++suite){
		for (value = 0; value < 13; ++value){
			setCard(ptr, suite, value);
			++ptr;
		}
	}
	for (suite = 0; suite < jokers; ++suite){
		ptr->value = JOKER_VALUE;
		++ptr;
	}
	return pcard;
}
