#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "hb-question.h"
#include "hb-game.h"

// hb-main.c

/*
	ルール：
	0～9で重複なしの3桁を生成する。
	プレーヤーはその値を当てる。最初はあてずっぽ。
	場所が一致すればHit、その数字はあるが場所が一致しない場合はBlowとして評価。
	プレーヤーは評価された結果から、再度予想する。
	3Hitに達すれば終了。
*/
int		main(void)
{
	// ゲーム変数の初期化。
	char player[20];
	HighScore highScore[HIGH_SCORES];
	int highLoop;
	// ハイスコア初期化
	for (highLoop = 0; highLoop < HIGH_SCORES; ++highLoop)
	{
		highScore[highLoop].score = (highLoop + 1) * 10;
		strcpy(highScore[highLoop].player, "someone");
	}
	// 初期化、問題の作成
	srand(time(NULL));
	
	while (inputPlayer(player, ARRAY_SIZE_OF(player), "-"), 0 != strcmp(player, "-"))
	{
		// プレイ変数
		int answer[DIGITS];		// シャッフル後に先頭からピックアップして問題を作る。
		int input[DIGITS];		// 入力バッファをintに変換したもの
		int hits, blows, counter = 0;	// ゲームの評価変数。
		int loop;
		GamePoint pt;
		buildQuestion(answer, ARRAY_SIZE_OF(answer));
		// ゲームのメインループ
		do
		{
			inputDigits(counter + 1, input, ARRAY_SIZE_OF(input));
			// 入力を評価
			pt = evaluate(input, ARRAY_SIZE_OF(input), answer, ARRAY_SIZE_OF(answer));
			printf("%dHit, %dBlow \n", pt.hits, pt.blows);
			++counter;
		} while (DIGITS != pt.hits);	// 3 hitsで終了
		printf("正解！！ \n");
		// ハイスコア更新（現スコアはcounter、プレーヤはplayer）
		for (highLoop = 0; highLoop < HIGH_SCORES; ++highLoop)
		{
			// スコアチェック
			if (counter < highScore[highLoop].score)
			{
				// 順位highLoopをずらす
				char playerSave[20];
				int scoreSave;
				// highLoopの人を退避
				scoreSave = highScore[highLoop].score;
				strcpy(playerSave, highScore[highLoop].player);
				// 現プレーヤをhighLoopにセット
				highScore[highLoop].score = counter;
				strcpy(highScore[highLoop].player, player);
				// 退避させた人を、プレーヤの成績に戻して続行
				counter = scoreSave;
				strcpy(player, playerSave);
			}
		}
		for (highLoop = 0; highLoop < HIGH_SCORES; ++highLoop)
		{
			printf("ハイスコア %d 位 \t得点=%d プレーヤ=%s \n", 
				highLoop + 1, 
				highScore[highLoop].score, highScore[highLoop].player);
		}
	}
	return 0;
}
